- Main Page
- Modules
- Namespaces
- Classes
- Files
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# CoinShallowPackedVector Class Reference

Shallow Sparse Vector. More...

`#include <CoinShallowPackedVector.hpp>`

Inheritance diagram for CoinShallowPackedVector:

[legend]
Collaboration diagram for CoinShallowPackedVector:

[legend]
List of all members.

## Public Member Functions
Get methods
virtual int | getNumElements () const
| Get length of indices and elements vectors.
virtual const int * | getIndices () const
| Get indices of elements.
virtual const double * | getElements () const
| Get element values.
Set methods
void | clear ()
| Reset the vector (as if were just created an empty vector).
CoinShallowPackedVector & | operator= (const CoinShallowPackedVector &x)
| Assignment operator.
CoinShallowPackedVector & | operator= (const CoinPackedVectorBase &x)
| Assignment operator from a CoinPackedVectorBase.
void | setVector (int size, const int *indices, const double *elements, bool testForDuplicateIndex=true)
| just like the explicit constructor
Methods to create, set and destroy
| CoinShallowPackedVector (bool testForDuplicateIndex=true)
| Default constructor.
| CoinShallowPackedVector (int size, const int *indices, const double *elements, bool testForDuplicateIndex=true)
| Explicit Constructor.
| CoinShallowPackedVector (const CoinPackedVectorBase &)
| Copy constructor from the base class.
| CoinShallowPackedVector (const CoinShallowPackedVector &)
| Copy constructor.
| ~CoinShallowPackedVector ()
| Destructor.
void | print ()
| Print vector information.
## Private Attributes
Private member data
const int * | indices_
| Vector indices.
const double * | elements_
| Vector elements.
int | nElements_
| Size of indices and elements vectors.
## Friends
void | CoinShallowPackedVectorUnitTest ()
| A function that tests the methods in the CoinShallowPackedVector class.

## Detailed Description

Shallow Sparse Vector.

This class is for sparse vectors where the indices and elements are stored elsewhere. This class only maintains pointers to the indices and elements. Since this class does not own the index and element data it provides read only access to to the data. An CoinSparsePackedVector must be used when the sparse vector's data will be altered.

This class stores pointers to the vectors. It does not actually contain the vectors.

Here is a sample usage:

       const int ne = 4;
       int inx[ne] =   {  1,   4,  0,   2 };
       double el[ne] = { 10., 40., 1., 50. };

       // Create vector and set its value
       CoinShallowPackedVector r(ne,inx,el);

       // access each index and element
       assert( r.indices ()[0]== 1  );
       assert( r.elements()[0]==10. );
       assert( r.indices ()[1]== 4  );
       assert( r.elements()[1]==40. );
       assert( r.indices ()[2]== 0  );
       assert( r.elements()[2]== 1. );
       assert( r.indices ()[3]== 2  );
       assert( r.elements()[3]==50. );

       // access as a full storage vector
       assert( r[ 0]==1. );
       assert( r[ 1]==10.);
       assert( r[ 2]==50.);
       assert( r[ 3]==0. );
       assert( r[ 4]==40.);

       // Tests for equality and equivalence
       CoinShallowPackedVector r1;
       r1=r;
       assert( r==r1 );
       r.sort(CoinIncrElementOrdered());
       assert( r!=r1 );

       // Add packed vectors.
       // Similarly for subtraction, multiplication,
       // and division.
       CoinPackedVector add = r + r1;
       assert( add[0] ==  1.+ 1. );
       assert( add[1] == 10.+10. );
       assert( add[2] == 50.+50. );
       assert( add[3] ==  0.+ 0. );
       assert( add[4] == 40.+40. );
       assert( r.sum() == 10.+40.+1.+50. );

Definition at line 71 of file CoinShallowPackedVector.hpp.

## Constructor & Destructor Documentation

CoinShallowPackedVector::CoinShallowPackedVector | ( | bool | testForDuplicateIndex = `true` | ) |

Default constructor.

CoinShallowPackedVector::CoinShallowPackedVector | ( | int | size,
|  | const int * | indices,
|  | const double * | elements,
|  | bool | testForDuplicateIndex = `true` |
| ) |  |  |

Explicit Constructor.

Set vector size, indices, and elements. Size is the length of both the indices and elements vectors. The indices and elements vectors are not copied into this class instance. The ShallowPackedVector only maintains the pointers to the indices and elements vectors.
The last argument specifies whether the creator of the object knows in advance that there are no duplicate indices.

CoinShallowPackedVector::CoinShallowPackedVector | ( | const CoinPackedVectorBase & |  | ) |

Copy constructor from the base class.

CoinShallowPackedVector::CoinShallowPackedVector | ( | const CoinShallowPackedVector & |  | ) |

Copy constructor.

CoinShallowPackedVector::~CoinShallowPackedVector | ( |  | ) | `[inline]`

Destructor.

Definition at line 119 of file CoinShallowPackedVector.hpp.

## Member Function Documentation

virtual int CoinShallowPackedVector::getNumElements | ( |  | ) | const`[inline, virtual]`

Get length of indices and elements vectors.

Implements CoinPackedVectorBase.

Definition at line 79 of file CoinShallowPackedVector.hpp.

References nElements_.

virtual const int* CoinShallowPackedVector::getIndices | ( |  | ) | const`[inline, virtual]`

Get indices of elements.

Implements CoinPackedVectorBase.

Definition at line 81 of file CoinShallowPackedVector.hpp.

References indices_.

virtual const double* CoinShallowPackedVector::getElements | ( |  | ) | const`[inline, virtual]`

Get element values.

Implements CoinPackedVectorBase.

Definition at line 83 of file CoinShallowPackedVector.hpp.

References elements_.

void CoinShallowPackedVector::clear | ( |  | ) |

Reset the vector (as if were just created an empty vector).

CoinShallowPackedVector& CoinShallowPackedVector::operator= | ( | const CoinShallowPackedVector & | x | ) |

Assignment operator.

CoinShallowPackedVector& CoinShallowPackedVector::operator= | ( | const CoinPackedVectorBase & | x | ) |

Assignment operator from a CoinPackedVectorBase.

Reimplemented from CoinPackedVectorBase.

void CoinShallowPackedVector::setVector | ( | int | size,
|  | const int * | indices,
|  | const double * | elements,
|  | bool | testForDuplicateIndex = `true` |
| ) |  |  |

just like the explicit constructor

void CoinShallowPackedVector::print | ( |  | ) |

Print vector information.

## Friends And Related Function Documentation

void CoinShallowPackedVectorUnitTest | ( |  | ) | `[friend]`

A function that tests the methods in the CoinShallowPackedVector class.

The only reason for it not to be a member method is that this way it doesn't have to be compiled into the library. And that's a gain, because the library should be compiled with optimization on, but this method should be compiled with debugging.

## Member Data Documentation

const int* CoinShallowPackedVector::indices_`[private]`

Vector indices.

Definition at line 128 of file CoinShallowPackedVector.hpp.

Referenced by getIndices().

const double* CoinShallowPackedVector::elements_`[private]`

Vector elements.

Definition at line 130 of file CoinShallowPackedVector.hpp.

Referenced by getElements().

int CoinShallowPackedVector::nElements_`[private]`

Size of indices and elements vectors.

Definition at line 132 of file CoinShallowPackedVector.hpp.

Referenced by getNumElements().

The documentation for this class was generated from the following file:

- /home/coin/SVN-release/Osi-0.98.1/CoinUtils/src/CoinShallowPackedVector.hpp